/**
 * Gmail Checker widget
 * 
 * @author David Håsäther <dhasather@gmail.com>
 * @version 0.92
 *
 * The sound is taken from wavsource.com
 */

window.addEventListener('load', function() {
  var label = widget.preferenceForKey("label") || 'unread';
  widget.setPreferenceForKey(label, 'label')
  gmailChecker.check(5, label);
  
  var newMessages = document.getElementById('new-messages').firstChild;
  newMessages.addEventListener('click', function() {
    newMessages.firstChild.nodeValue = '0';
    gmailChecker.resetMessageCount();
  }, false);
  
  // This one is ugly. It "resets" the widget which will otherwise look active
  // after the link is clicked, i.e., the link will stay yellow and the close
  // button will be visible.
  window.addEventListener('blur', function() {
    document.body.innerHTML = document.body.innerHTML;
  }, false);
}, false);



var gmailChecker = function() {
  var _messageCount = 0;
  var _notify = new Audio('data:audio/wav;base64,UklGRpAeAABXQVZFZm10IBAAAAABAAEAESsAABErAAABAAgAZGF0YWweAACAgICAgICAgICAgn%2BAfoGAgIB%2BgICAgH2FfYZ6gH6Chn%2BAd4GAhoB9gHuFfYV%2BhH%2BAfoCFgIR8gH2Ag4CGfIB1gYKKgXt3e4aGhHt7foOBgH%2BDg4F1eYCPjH1ucoaSjXhweYaLgXp7hISAc36GlYJ3an2TlYZsbn6Pjn94eYKCfnuBh4d4c3WJkol7bHmEjot%2Fe3l%2FgYWHgoB0fICLhIF6e3%2BAgIGFgn5yeIWQkHhwb4uQkHlye4SMfn98jYN6cHuUlIdjbnueln9qa4aOjHh3gIeDdHiAlYd4aHWPlYxwb3iLj4CAdIN9gH%2BBioB%2Fb3%2BDjYd6eXiAhIeFgHh4e4ePhnxueoSOhnt4f4KDe36GiYRvcX6XlYBnaoKbkntqd4mOgHV9iY19bHeLnYlwYHuVnYRqa4CSjH51gIWDenWEjI54bnSHl4d8a3uDjIV%2FgHqAeYSDi4B4d36Jh4J9eoB9gICJhn5xcoOUkH1ocoSWintwfomGfHiBjop0anmTnYJqYYCXmH5pcYWQg3V5hI%2BAcXCHmJB0Y3SOnYlzan2KjYF6f4GAfXmFh4x4dHWFj4aAcnx%2FhYSEgH53eoKLjH51dICMhYB5gIGAe36HjoJyaoCUmYBpaIKWk3pveImMfXd8j4x8aXKOnI5rY3iVnIJuboCQhnt3goqEcXd%2BmYt%2BaHGJk5B3c3WFh4SAfoF6f3uKhoZ4d3uFiYR%2FfXx%2FfYOHiYBwc4CSknxwcIWOiXt1gIeCeHiDlYZ4YX2OooJrZX2bkIFpeYSOgHV8ipB9bm6KmY91YXeLnIV1bn2LhYB5goOCd3mAj4p%2BcXWDjIt%2BfHWDgH%2BefXB4gYCEjXmEbnqFjYJ7e36KeXmAlI1xYnOhnoBda42ehW94iY9%2BdXmMjoV3b3uDlY54aGmNmY5uZoCSjXFxh5iEZ2mHoY5yY3yLjoF9fHp%2BfomFgnl7gYCCgYeDenR8i4%2BAdXmAgnyAiYt0anSYl4NicYeYgnF7jZB4aXyUnH1ra4KQjoJ0cnSLj4pycIGPiW90i5yGYmWHqJVsXnmbkIBvgIOBfH2KhIF3f3yBgYuEe2t3jZWEb3KAi4CAgIt8cXSMmIFvboeOgHN8k4Z3YoCXmHpmc4WVhX95eX%2BBi4F9eIOHgG96kJyAW2WOrpBjWX%2Bgk3RsgJKCc3WHkoN5coCAi4eGd2x7jZuAbnGFkIB1f4%2BGdWmDlpNzbn6Mh3eBh4xxaoCYm3JqcJONg3V%2FgX99f4aDf32Af3eAjZZ8YWmQqYtjXoSgjWxqiZiCZ2yKnoZxZ32KjYZ%2FdXJ8j5KBbnSJjn9xf5WNcWV9npd5ZXeOjH95hIZ7b36Tk3tqeYqOfH1%2FjH11eomSgHxyg3yHhY58am%2BMoIpqY4SbimtujpuAX2uQpoplZn%2BYjoB1en6AioSCdH6GhXxuhpOSa199nqF0Ym%2BTlH51fo6Ac3eLlYBycoaGgXyFhH1ufYyUgHB3gIp%2FhYGCcXSElI1uc36ZgHNyk5l7YGmZo4lgY4SYj3d1foGUfWXIbk6KhYJbnJWLUGOZi5tqcG%2BAnZdra46dflOArphgaY2TeXeTnGZgjaaKYn%2BMiWiBmIlndIx9eICVf1l5noxXfqaTTVKpv3w7cqqbZm%2BYhml0nINmfaWOV2CfqntlgIZ3gKOVV1WfvXJFfceTRlWluHRZgJZzcpefaVaCpoBggJx7W4CfhWB%2BnYBPdbWfT1Sip2pWmbhyQH3BmF1nlZJqf5WNYn2Wh11zr55ZTZSrgGaElmdenrlzPXm%2FmUpVsrNrTH6phnuChWJzoqhsUoqigF1%2FqYZZcaOJX3SulkdTpsRwQ3e0g1Z5qo5XZ5iVcHeTgV56oJNfa6CYVleju3FAfLGKXH%2BqgE13uKBSXKKvaFKNs4Vlc4x%2BgZ%2BWWU%2BbwoBDdLSVVGGoo2ZclJ1hXqaxZzaAvphOZ5iQZnOYimhzm4Bgc7SVVE%2BlsGlVlLhqQ4HHkktmpplec6adWVmhp3JXlqF5VIWjg2yCkmhhncFzM2%2FKp0tOqbRlS4uvfV6Ll3BNlbuDQGGqnG5pk4RoeZ6LW3WslktTrsVsOnu8i1J7rpJHa6ipYWCYmWlgnaJ0WIehcmaNq3NTf6qDXYSqfkB1yKlGRKK9ckeEtYRWcp%2BEb4eddEyAuJlWXZiYcHGYjl9unp9XXaK6ZzOAxZ9LX5iba2%2Bcj2phnY2GZ33rRCegtXVSmZdmSq%2Bjck96r25yhaaBYG%2BTnIRvap2TcWqNpYBhgpZ7c6KZW0ulxmw2j71mPZfHZiaZ2Fwelut%2FFmnOmE17qXNMlcFpQI7CcESGuYZWgJV%2FcY6Wf3J8gIuZhl1yqJtYZbWlUkeqvF1PpaxLVLCzR028pS5K3sUlIMXYRCm4zEM0uMZPPbLITjulx3FZi5Bif7eOR2GspWNgkpR%2BenN1jKqATG%2BykFWAsX42fd2TKWfWnStl1qUwbsOPL4Tbgh5n7ZYhY%2BqbE1LiujBLuqdGX7qZS2ipi1R7q4dXdJR8eZSQX16UoXdygHtumJ5gTqjOUySW738jgMx8NKDdZRyU73kejuR6I4%2FWczGj2VcXmP57EnHfhTZ7woZBe6CDX5KQaGaQlWJ7l4RXd6WAaoKiW1yft2NOpaFUVM2zNjnT0zIjzfFCFKbfY0CuuTpAztc5KrrUSjS4y089s7dJSb%2FFTDaSwntlfYNxhZZxY5KhZVeTqm5jl5JWb7OfSmazlD9115UkXOGmJF%2Fnpw1S7L8cQt26KEPUuUBSvZQ5eN6XFlvbsjhUvKZPYaeWYH2hgFh9oId8gHNfj7uCOHHCkkJsvY1Je653QKDRYhOQ7XkbiedsDo76fgiA7YINguqLHXPTgz2Dy3U4h795R5i3aTuQw4FhaaGmSoGVZ42ZbEygt1tfkJ9NerSgT0yisn5CjbVwRJzETUXB0R4v2uM2Jb25VlKop19Ujax%2FSoO9ejyKv3RLp6JLXseYQ3irc2WbkmCCoGdgna9oWYShjGFoobdUP6%2FFTUTNrxhV96gPYuCFKIXLdzx%2FuoZJW7y9SR6v4V00qq9CatOHNoXDaVSenWGAnW5hl5tyeYNzf46Ke4BpeLCMPHPmhAh9%2F4EFk%2BhmH6rPZkOUr2tZj7eBOmXPpytf3ZcRdPGCEozbaDKWsXB4hmVvqJlfbIeAgYtxc5WGZ4KTZYG8dyiU32gvu8YpQuvMGEXTvkJPo713R3i7iUKD0G8Sn%2FJUFbreLSvPxTtQro1hfI2Ag4BfhJ17ZZaMYn6Vc3%2BxcDSV22Y2r7I9Y92GI4XqcB6G2I1GaJ%2BiaFiqvEkky%2BgzG9XVJj%2FYnzJ9zWkxlsGAVHWGl4ZgfqOFS4Oud2WYjVWHqmVguZgtcN2FKovOYjiivmVYjphyb4eghElwyp0dZfaiAF78lhuD02Uzp8NlUIyXgHh4g5Z1Z4%2BWWXW9iS93xoZUjY1UibxpPK6%2BSUW8rExorJBVcZmleFVzuIpCgNVuHJ%2FrUhzG3S0p1NA6Sa6uYF%2BGpo1gYZ2YXn%2BwdzaYx2JFqaNYaJmjJrqvGqOccICQgHpYc%2BJ5MoCygIFWcuN1EarwI0T%2FmAxw2ZhLYLOjN2LejDN%2FqYV5W3XdfQWf7TxA3YIylqded5OEcFmHuF1VtXNDsqA2jqxchJdPntQxTuqHI5zdby9r4b0KW%2F%2BEDbLGQXesdYB3UMHOFz%2FyliiGvntObrifNGfVbjavkEWesDZyuHd0mWpxqmxpqYdXgpV0eXyfhzp66mgMyOIlQNSeWHuGnYJNgNd5M4u0fVx8opA6eOBhFMjaI0nGjG6Qc3CbfnqVem6TfnOVeHOWem%2BZZ2fPghKX4UFP0IMyibKAWWivpzdV0JtCdZiOgE575HEKsOsrTeCVMH2yiW9pnJZVcbl%2FV5SFeJVrYsOVMIq0V4u9TkrKnUV%2BqIpgaayZOXThbxylsmF8iWeTgE%2B5tRxS%2B5IUddSZN1O%2Bry9r3mkqq65Wg49emIxMnLpDW8p%2FS5WeeWx7ko9ej65HatZrJ87KG1%2FBjnOAY5SnSXm%2BeUKdp3JPfM%2BYD2z%2FYg7Q1RdP0JRuZ2ylp0NivINhhIN4fHqmkjJ52WY5yJ0mlb5Qart4Xo6Hgnp1nJdHb7%2BDYn2AlJM9ePNmCbjfJ1nXhzx6sZVZV7mzOVu5mGp%2BcZCdR3vebhK1zTtnuXVdm4dmeIulcUmOqmJ6tUlVyHxjg4CFgZU5l%2BAWY%2BJxPYertS8885kmgtBwRpK0YnyUaah9L8fRDm7Xfllqp7VFWL%2BBWJWeZVuok0SgoDKWo0yTjE%2Bmh1aCiZR%2BZ4%2BLXZOrfEJw9msKysUwfpt4mWF4uXBPhqmVVGiygF%2BDnZc7bvFXHtGnN4mDeJd1e4R%2BhH19kn2CfmqbgHmWXH29RGboWDq%2BoExurp1WZrOAanegpT9WzJJWfl%2BqshSA6VU5vaNJX8GqOnShhIJsiqFJecJZfJ9KnK82esFwaI5%2BYo27VUfCi0eNjphsP8SqF5vUQmeigYl3dJCfYkyw0SNQ6nw7gKi1SinirBqctVN7m391gYt9j4E5qc03brBfgJZvnGFlw2tOwoJAl71ZMsLIMmGmcZyDQbqLNqOpYXhzoqEpc%2Bt%2BHoHqZg%2FM0Cd1nXGsa07Hf0eWjoGJXI%2BVX4CigVJ9zVU914syt4VAqJl3eV6ZpVdzooFqcZuLZYB%2FlZspdP9WIM6TR4Wmj1xVvKBQZaWoYVeji3ePXJSvLnvtTUe5gmGJk4BnhZtrdZCNgF2NpkqKv0J0u1h8oVyTokldvqdJS8aXOoCil1lMxakMjt9LaJVrlotdkJ1VX7e5Nk3Xi1N9gKt8TK%2BKNL%2BsMI2mXnyngGd%2Bl3GFlVaUqEWArmGEh3eeTWHyeQmp2FA3sMNQV59%2BlnpNu5MulLlbfnKWqTpb5IYlmK50PbXBHZyKWLp7VpaCfY9ob6yJZoB8ebVvXqKGVILPaxbUwg2NuWuMTZjGI3PNh15QkL5mY3SXtw2A90Mxzpg2gK6LZm%2BJrltmvnB6gHCTgpBuartbWOhKWeA2b8Z7Z2OpszNnw4lzTbCUKKPUQVCpg5N%2BSZbbNzrmkkRpta8kWN6XUFiVwS2J2x6FvEWej0Wvll9nirJcbqNqcZZ3hnt9mF5rwpQentM4Y7qBem50q3NxgIumQ3PFYWuZfJ9AXP9rFKm3a1SSoWp4iXmOeGqqhll6nYCBgWqbcGjGcDfFjFOKjIRol6Uxg8pigXBzxlJcynlhgnSihU%2BAun4ol9lPPcKoM3DCgG9jgsJTQdqAWYtUs6BEfqCJYmfLZjzqZkGug3uMb418X6yVWWyqflmjiWh6lYB3gG6L0Dcp9pI8hoWjZj%2FdkC2JqoxHcc9jYKFflpY4q7s2WMOZU3SWlWplnZ5WipRjfZegQn%2FOQ2jHT4arP52KXZ6Jf2dov4BNkJWQUF7xeAm72zpJsJiDdVWboVWDpnFjc7mHOJWbkF1D3ZcJxq4kl5Z5i3V%2FcoWiZ3qNb59yXamJboB5fqloVs6AGrnFMnG1mEdVz5ZQdXy7cyrNoEWCdJS3FI%2FkWUl05EtXwntUatZYjlWHvFCJcq5PumpB50aQjnhqiaBXlJlvN8u8ALSDioUc2IVPbL9sL7mBm0CNi4qhD92pTj3B1gCxg5x4OtGNXVzZVGWuZq5HtGVj1iarokVmsoJTrFObeX6jPKaMpjRc9Vhee8xFSt1oimtwlrJKW%2FFHg3KPtxOrsXw5W%2Fd9JIHoMXW5Trthe42DhlDIYX57gJ9SonWUWXi5XXeCvgyh0w2xgYZgarGEa1izg4BMitc4lGiDuy6Ut3kXudsjd5uwT26pgotGvoB5YYDdN5NjddRDb66CN8eGSaB%2BrC%2BYsDexb5BocZaTb1bVTWWofodjk16%2FZjfdhG8vxcMVj56cVGyUtFZK%2Fy1vo3S1R4N3r4BCoKtxMdZ%2FSqJ0qE5%2Bh4x%2BacEhistXc3qsXoWDfYCEl0XMRGj0PH1wnJ9LdbqcCKfBeEF69yh%2BioagYYJvxUJx01x3bKiAamK7nwmvm4BlatAok7E7kJ5wZ6BXn4ZSvVCUY42nYIdOu4Zcd6yUGsioPGvFmDuJcMt3NMRxi2GEsGhseap%2FaFzPjwfYh1SLkJdJi4WUeWeda5Nnk3p%2BoFKMf5tfko46215KuZVhW6uJb126kDiXfrlSVt9SbI%2BPfYBuedU7VLO7WS7NgXhjnps5n3quUmXQUHeWfmO1bFnDQZSGjoE6yGV5nXlqf6hohk%2FDpRGhq4Q5rqZKlWOrgG%2BBe7U7gLWJRX24aYw51qAAsql7SZSoY311kHmnXW64QaaKdXd1o2iVVKeSQbF9anLCcEOohX5G1m9BrFfKY0mrm3NZnH2wTnC%2FYXlm4WkX05liUMSCXoVow2djkJN5XKNitVxht2OSU7x%2FPb1%2BUIzGOn%2BVbqpGqYVZlYGeRJKub2h0p26hVXLMS2Cj1hpm0HOQLcGiRIOJoUaPoYNHgbJVwzRr6TlyjLFTaal0gGKybHqHdJ1GxIBPgKGUJ9dyW6tYk46AX6WCW46MtB2Px1eAOeOlCYrMczfKenpyabVxjz%2BpqTqPg6pCiqhigUzWkC1%2BvXFT3zKCn3OSRcZuap1gloF3d7pNb6phxkJsuX9VcPA9Q8OZXEHZgmFnf7xuYmveTViwWNVCX8pvVYHVU02btVJZ4DqWgmWvW46Cj2mBklPFdG5yjot7pTOcp3tDhu0RhbhifV2yoFNE0YVEpXilRn6wZ6cyktRSMrPaIIGPknVfs3t%2BUriBR7tui2COi1%2B5X2argEmulzHPYm%2BLc708iZ5%2BW2%2FXfT1f8WY5xWqLcoB%2FlH5B5m9Agqe3LneqmEZ1x35UTf9WNt5KnoVifJWNZptqgXGgj0SxZo97aLdgfICrPHrzJmupnEl3q4KGN7SGfXpU8D9fn4SoTmW0qAyn2y1yksQ9Vct6kEeCm4l4X75Mi4J5o2J1g70jnrcxsXyLRovXP3mQiV%2BgfoODNuhvP6qCnFOCeaiKMa6obCXD0B55nKlBgJyNhhznekOueZNlgHOue1OUlp8Hx7UwsGqAeZKOcnlyv0l6snRqdMhJcaKAkFiZVrWHM9pqTYa9fU1zps0Aic17aUTrVVK3gIBwfG7IXU3LanhftIVYhoCyMoS0bnljuVB8t15ppZQxt3t%2FpTKsf4V%2BZ65qfHGpdW98nagFsMxOWZ2sPIeUk4Q4o52GVnqugGtnqX17eoW0Dq%2FOOnuSj2GOhIF6d55WpWuClVmrZXePk3pnmVO7gUGcrmc4y4prX5ewK5yMj3RExIxFgKx5fnFY22dJpZt9JMisRnSPn1iOepJ9ZblZcZCiYn6bNM15bodzl16peV2doE9py1eFcY7CCI%2FOgUB6w197f5t7dYByw0VrvJJFWeBvammUyhZ8yoBOhqBei3igXI%2BLOdpba6lmf4CUZY54lIRCsICCZ6KJH8ymaDS4uDGUepiQT4KqfT%2B4iYxcRu1vYnGnoBOszkw7z5JLjl%2FCel6Bf6ZTmXuDhFapeoZol4VKq5VcZdpSQd1fiWiJsDuKk5tYfZiHYWLZXYBnW%2FlXP4zfTTPRhm5UuJVHcZm6R3WOintgxFCNgkbebz2ZvVtfnXuSZrFZWMtilVmQqESAqJgqsJlUjXeZeI9Pk7Q5jZKyM1frbGJht6cvXN6gCreJb5ZTsG6Jb3e5THGoqjN3rnqQTaqEU4ughzbHekq4eXtftIxLgYaffIBCupM4xV2balzIfkd05GIvnMZuKNOLVX9xxHJhZbWWMqx5oWZVtI1iYNpQXZihfS%2FnZVSwX5SFgHKBcJegQKF4hn5rqGCjVnm9aU2G8TI7x5ByXap8d1ewuheZi6BvRbiDk1Rru4wzkO0ba66HjEawenGDg5hOoYN4boucVK5qa5CPcXG%2FLqKiP5uGqUNmupdTXsx5ZlDNoAnIh3J8aZyQhzasm1hzpawjfLebWETTg2hUr50wynNZlYV3jZBMnXqKgG%2BqP6iQVpZyonFrhKVXbudBTp%2B%2BYES%2FfIZThrBzelLBgkmSmYxXd5ezMWr%2BPVaTqn8%2FvH9ueIOQjHVOv25%2FhmCxa4Nulm9%2BxTl4no9egLxHa5%2BoS3iqa5tAorEynJCCZ2%2BTp4QrlLKPLYTxJW6im2NhsICARaqmTIqCjmaKc5WdQY%2BGn0581i2Hnm57loNmhHi6S2bHc3FWuIZTp31zcpV%2BlYA2waFOXbqhP4CMuzxZ6XRXUMacRJCFeXubVqqDNsx5aWyZrEt5iphpeqFydHG0X26%2FXWaLuUR%2Fq1%2BjTYqbgW9spX5yc71oY4OKqRW1zipYsLJGeYadfFWXg5tSgapld3O0fmB3j6o8nq5BeLOETpyAhH9ynE%2BygWyGXa6EaICWcnuPXcNlU56oaTjPmExroJ9GjpWHZl%2B4i1xwsHVvgmHWYz%2BmnX9Ar55UdKZ8XKhwlmlqsWKEjn9lhKFeln5zg4mAZ6NwdJyGU27fY155jbwzgbl1SZSuY3d3q3Bygm7GUmK1gFd1x3FhaqeiP4Wgik%2BNm16YfIVnkI9VrHdsm3hrk49oj3KFg2C6bGp9nI48paldTr2SSYuApXNYgaKYQ5WFgnVuu2tegq%2BAPJi6aEW6gVmla5l5YZSBl2h8gYqAdYtzl2iPf120gGF3s2dWwnVvc5aMYIGWjlSAlY9vYLJ1dIBmxmxEoLNUVLqNcVamiV%2BXe5lXe6OAd2micY54Ya%2BAaH6jXH2pboJrnnBvt2V3eZiOX3KokkCjhGuQeJZsgHOPpVB0n5lHebp7ZWqri1h0rpA4oI9sj2%2BPf315f59wcY2YTY2lZ4lhm41hjIZ%2BbqZwX56WdVilfnSHgItvgmyohEychYRwb6KHXX23XF%2BeqXA6tY9ohnCWg2x1oIBlkH6SY36XhHNrq2pumI5wZax0Z6F6eYKEdYl5ipBTl4KCfmuefoBrfaiAWIG7SnOvgWxjqYF1b46fVoSHinNzm4B%2FYYWjhlJ5wk2AmXV%2FdZV8cYONgHKKeIdylYRcmXx6iYR0gI1njZZfgJSMWH6iiWJurHtwcaGURJuLcoOAgIl6YKiHbHCQokyDmIJ0cJ2AcHWigV6XeHuOi2p8lW%2BQeX2DgI5ji4twi4N8coaEmVl3tWFslZZwX6ODem%2BHj4JxaKp9cICMgmeJhpZYfLJmZ5WVc2qQhXmAg3qKgWaddX%2BObI55gICKeIGJaYSUg2GAqGF7j4lsf5lwgG6Xl1x6jYx1gHmUf2GUjYNYibJYbp2FdX2FgIBymINpg4CScIV7go1qgoSNa4GVY4aPeHOWf2%2BFgJZscp91eXyVhGKKh356i3WMgF%2BlgG90noxXgI6bY3OXgHh1nnlxg4x8eotwk4RglYN4gIeBb4CNh2%2BCgn2HdZRrfp9vb4uXan%2BHfYR3hISEcH2Tf3p4ln5rh4aNZnmrbGaTl2p8g4WGaI2Ai3lqmX5%2FfYZ9fIGBkGKGknd0iotqjIZygICQcYKEd4R%2Bh4J4dJWBc4V0loJjhZKAaouUaHiQk2OEgIl9cZCFeXSMhXeCeo6FZYWQgG6FjnN8h4pplHx5h3WTeniFg3mBiXWCgIJ8fYl5jXxvjIp4c5eAa4OJjWx1lIdsfJR6gH6DgXOOeox8aJWMc3KWfX16hY5rhIOEdX%2BNeoCEfXqFi3KEgH2BhHmBi3OAhH6Ed4yAdIKJgm%2BCkn5mjJVrhHyFgXiBhYVwgIuCeXqOgHt7i4Jygo97bIuPc4CAeY16gn2Df4B%2FgIB9inWGfn2JeImBc3%2BSgG%2BMg3p8h4Zyg4GGeHqMgYBxioV6gHyMgXF%2BlnpyjIN7eYaLcYSAgoB7hYCAeYt5goB7iYB8e4qAeod7foKHe3iLgnl%2FhIF%2BfoSGcICQd4N6hICAf4CGenyEjHJ5k4B7eImGen2DhnOChn5%2FgICAgn2BgYB5g4R%2BeY55gIB%2FhXqDgH98hoF3h4CCcIuFeoB%2Fg4CAe4SEeIGCgHqCg4N1fouCc4SDgHWDjHSCfoSAgHqFhXiDfIV%2BgIKAfYCDgXqCgoB6iX98hIF9f4SAf4F%2FhHuAhICAfIGDfoB%2Fh35%2BepB7eYeAf3uGgH9%2BgoR6gICHfnyCgIN9gIKAfX6KfXyEgH6AgICAgIN9f4GBgIB%2Fgn6AhXqCgIF%2FgX2BhHyAgIZ6gIWAgHqJgIB9g4J7gIGBfIN%2BgYB8g4F%2FfYKCfn2FgH9%2FgYCAf4GAfoGBfYJ%2FgnuGfIJ%2FgIB%2Bg3uFf4B%2BgIJ8hH6CfYCFf36AhnyAfoR%2FgIF%2Fgn6AgYB%2Ff4N%2FgX2DgICAgYB9goCAfYKAgICAgICBfoGAgIF%2Bgn6DfYJ%2FgIJ8hHyFe4KAgICAgn2BgICAgICAgH%2BBgICAgICAgICAgIB%2Fgn%2BAgICAgICAgICAgX6CfoJ%2Bgn6CfoJ%2Bgn%2BAgICBfoM%3D');
  
  function process(request) {
    if (request.readyState == 4) {
      var newMessages = document.getElementById('new-messages').firstChild;
      var doc = request.responseXML;
      var fullCountElm = doc.getElementsByTagName('fullcount')[0] || null;
      
      if (doc && fullCountElm) {
        var fullCount = fullCountElm.firstChild.nodeValue;
        
        if (fullCount > _messageCount) {
          // _notify.play();
        }
        
        newMessages.firstChild.nodeValue = fullCount;
        _messageCount = fullCount;
      }
      else {
        log('Gmail Checker widget: Unspecified error!\n' +
          'HTTP Status: ' + request.status + ' ' + request.statusText);
        newMessages.firstChild.nodeValue = '!';
      }
    }
  }

  function log(m) {
    opera.postError(m);
  }

  return {
    resetMessageCount: function() {
      _messageCount = 0;
    },
    
    check: function(interval, label) {
      log('Gmail Checker widget: Checking mail @ ' + new Date());
      
      var request = new XMLHttpRequest();
      request.onreadystatechange = function() { process(request); };
      request.open('GET', 'http://mail.google.com/mail/feed/atom/' +
        encodeURIComponent(label), true);
      request.setRequestHeader('Cache-Control', 'no-cache');
      request.send(null);
      
      if (interval) {
        setInterval(this.check, 1000*60*interval);
      }
    }
  };
}();